summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRichard Maw <richard.maw@codethink.co.uk>2014-03-10 16:59:07 +0000
committerRichard Maw <richard.maw@codethink.co.uk>2014-03-14 10:54:55 +0000
commit8fd1da1a64fc48ccb070bcc52766a547c85cbecc (patch)
tree8180d72f6e074d0a7bc1dbb58c89c8385e3ce23f
parent6102336c2db3a84dbf7db2900b2df381bc823f3b (diff)
downloadmorph-8fd1da1a64fc48ccb070bcc52766a547c85cbecc.tar.gz
Add sysroot write extension
This moves the deployed system to somewhere on the host. Any existing contents of the directory is deleted, so don't try to be clever and deploy a new system on top of / in place of a proper upgrade. It can be used to deploy a chroot, sysroot or container, but its current use is to allow for nested deployments to include another system in itself, since the parent deployment's "$1" is prepended to the sub-deployment's "$2".
-rwxr-xr-xmorphlib/exts/sysroot.write29
1 files changed, 29 insertions, 0 deletions
diff --git a/morphlib/exts/sysroot.write b/morphlib/exts/sysroot.write
new file mode 100755
index 00000000..1ae4864f
--- /dev/null
+++ b/morphlib/exts/sysroot.write
@@ -0,0 +1,29 @@
+#!/bin/sh
+# Copyright (C) 2014 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# A Morph write extension to deploy to another directory
+
+set -eu
+
+# Ensure the target is an empty directory
+mkdir -p "$2"
+find "$2" -mindepth 1 -delete
+
+# Move the contents of our source directory to our target
+# Previously we would (cd "$1" && find -print0 | cpio -0pumd "$absolute_path")
+# to do this, but the source directory is disposable anyway, so we can move
+# its contents to save time
+find "$1" -maxdepth 1 -mindepth 1 -exec mv {} "$2/." +